package jp.sourceforge.jirc;

import java.awt.*;

import jp.sourceforge.jirc.net.*;

class AWTChannel extends ChildWindow {
    private boolean barLock = false;

    private List list;
    private Panel panel;
    private TextArea ta;

    private AWTFrame frame;

    AWTChannel(String name, IRC irc, AWTFrame win) {
    		super(name, irc, win);
    		
    		this.frame = win;

    		list = new List();
    		panel = new Panel(new BorderLayout());

    		ta = frame.getChannelTextArea("", 17, 54, TextArea.SCROLLBARS_VERTICAL_ONLY);

    		panel.add(ta, BorderLayout.CENTER);
    		panel.add(list, BorderLayout.EAST);
    }

    Component getComponent() {
		return (Component )panel;
    }

    public void addUser(String nick) {
    		int count = list.getItemCount();

    		if(count > 0) {
    			for(int i = 0; i < count; i++) {
    				String item = list.getItem(i);
    				int compare = item.compareToIgnoreCase(nick);

    				if(compare > 0) {
    					list.add(nick, i);
    					break;
    				} else if(compare == 0) {
    					break;
    				} else if(i == count -1) {
    					if(compare < 0) {
    						list.add(nick, i +1);
    					} else {
    						list.add(nick, i);
    					}
    					break;
    				}
    			}
    		} else {
    			list.add(nick);
    		}
    }
    
    public void removeUser(String nick) {
    		isRemoveUser(nick);
    }
    
    boolean isRemoveUser(String nick) {
    		int i = getIndex(nick);
    		if(i > 0) {
    			list.remove(i);
    			return true;
    		}

    		return false;
    }
    
    int getIndex(String nick) {
		String opNick    = "@" + nick;
		String voiceNick = "+" + nick;
		String items[] = list.getItems();

		for(int i = 0; i < items.length; i++) {
			if(opNick.equalsIgnoreCase(items[i]) 
				||voiceNick.equalsIgnoreCase(items[i])
				||nick.equalsIgnoreCase(items[i])) {
				return i;
			}
		}
		
		return -1;
    }
    
    public void setChanop(String nick, boolean flag) {
    		setNickHead(nick, "@", flag);
    }

    public void setVoice(String nick, boolean flag) {
    		setNickHead(nick, "+", flag);
    }
    
    private void setNickHead(String nick, String head, boolean flag) {
		if(flag) {
			removeUser(nick);
			addUser(head + nick);
		} else {
			removeUser(head + nick);
			addUser(nick);
		}
    }
    
    public void renameNick(String oldNick, String newNick, String message) {
    		int i = getIndex(oldNick);
    		if(i > -1) {
    			String string = list.getItem(i);
    			list.remove(i);
    			if(string.startsWith("@")) {
    				addUser("@" + newNick);
    			} else if(string.startsWith("+")	) {
    				addUser("+" + newNick);
    			} else {
    				addUser(newNick);
    			}
    			appendCommandMessage(message);
    		}
    }

    public void append(String message) {
		ta.setForeground(Color.BLACK);
    		ta.append(getTime() + " " + message + CRLF);
    }
    
    public void appendCommandMessage(String message) {
//		ta.setForeground(Color.GREEN);
		ta.append(getTime() + " " + message + CRLF);
    }
    
    public void appendErrorMessage(String message) {
//		ta.setForeground(Color.RED);
		ta.append(getTime() + " " + message + CRLF);
    }
}
