package jp.sourceforge.jirc;

import java.awt.*;

class AWTMenuBar extends AbstractMenuBar {
    private MenuBar menuBar = new MenuBar();
    private MenuItem connectionItem = new MenuItem(getMessage("connection"));
    private MenuItem disconnectionItem = new MenuItem(getMessage("disconnection"));
    
    private Menu commandMenu = null;
    private Menu channelMenu = null;
    //    private JMenu operMenu = null;
    
    private boolean hasMenu = false;
    
    AWTMenuBar(Window window) {
    		super(window);
	
    		if(!hasMenu) {
    			commandMenu = getCommandMenu();
    			channelMenu = getChannelMenu();
    			//	    operMenu = getOperMenu();
	    
    			menuBar.add(getFileMenu());

    			//	    Menu menu = getEncodingMenu();
    			//	    if(menu != null) {
    			//		add(menu);
    			//	    }
    			//	    add(commandMenu);

    			menuBar.add(channelMenu);
    			//	    add(operMenu);
    			hasMenu = true;
    		}
    }

    MenuBar getMenuBar() {
    		return menuBar;
    }
    
    private Menu getFileMenu() {
    		Menu menu = new Menu(getMessage("file"));
    		MenuItem quitItem = new MenuItem(getMessage("quit"));

    		menu.add(connectionItem);
    		menu.add(disconnectionItem);
    		menu.add("-");
    		setMenuItem(menu, getMessage("preferences")).addActionListener(new PreferencesActionImpl());
    		menu.add("-");
    		setMenuItem(menu, getMessage("quit")).addActionListener(new QuitActionImpl());
	
    		connectionItem.addActionListener(new ConnectionActionImpl());
    		disconnectionItem.addActionListener(new DisconnectionActionImpl());
	
    		disconnectionItem.setEnabled(false);
	
    		return menu;
    }

    private Menu getCommandMenu() {
    		Menu menu = new Menu(getMessage("command"));

    		//	setMenuItem(menu, "OPER");
    		//	setMenuItem(menu, "MODE");
    		setMenuItem(menu, "NICK...").addActionListener(new NickActionImpl());;
    		setMenuItem(menu, "JOIN...").addActionListener(new JoinActionImpl());;
    		//	setMenuItem(menu, "NAMES");
    		//	setMenuItem(menu, "LIST");
    		//	setMenuItem(menu, "PRIVMSG");
    		//	setMenuItem(menu, "NOTICE");
    		//	menu.add(new JSeparator());
    		//	setMenuItem(menu, "MOTD");
    		//	setMenuItem(menu, "LUSERS");
    		//	setMenuItem(menu, "VERSION");
    		//	setMenuItem(menu, "STATS");
    		//	setMenuItem(menu, "LINKS");
    		//	setMenuItem(menu, "TIME");
    		//	setMenuItem(menu, "CONNECT");
    		//	setMenuItem(menu, "TRACE");
    		//	setMenuItem(menu, "ADMIN");
    		//	setMenuItem(menu, "INFO");
    		//	menu.add(new JSeparator());
    		//	setMenuItem(menu, "SERVLIST");
    		//	setMenuItem(menu, "SQUERY");
    		//	menu.add(new JSeparator());
    		//	setMenuItem(menu, "WHO");
    		//	setMenuItem(menu, "WHOIS");
    		//	setMenuItem(menu, "WHOWAS");
    		menu.setEnabled(false);
	
    		return menu;
    }

    private Menu getChannelMenu() {
    		Menu menu = new Menu(getMessage("channel"));
	
    		setMenuItem(menu, "PART").addActionListener(new PartActionImpl());
    		//	setMenuItem(menu, "MODE");
    		setMenuItem(menu, "TOPIC...").addActionListener(new TopicActionImpl());
    		//	setMenuItem(menu, "INVITE");
    		//	setMenuItem(menu, "KICK");
    		menu.setEnabled(false);
	
    		return menu;
    }

    /*
    private JMenu getOperMenu() {
	JMenu menu = new JMenu("Oper Command");
	
	setMenuItem(menu, "SQUIT");
	setMenuItem(menu, "KILL");
	menu.setEnabled(false);
	
	return menu;
    }
    */

    private MenuItem setMenuItem(Menu menu, String text) {
    		MenuItem item = new MenuItem(text);	
    		menu.add(item);

    		return item;
    }
    
    public void setConnected (boolean connected) {
       	connectionItem.setEnabled(!connected);
       	disconnectionItem.setEnabled(connected);
       	commandMenu.setEnabled(connected);
       	channelMenu.setEnabled(connected);
	//	operMenu.setEnabled(connected);
    }
}
