package jp.sourceforge.jirc;

import java.awt.event.*;

abstract class AbstractMenuBar {
    Window window;

    AbstractMenuBar(Window window) {
    		this.window = window;
    }

    static String getMessage(String string) {
    		return ClientMessage.getMessage(string);
    }
    
    abstract void setConnected(boolean bool);

    class ConnectionActionImpl implements ActionListener {
    		public void actionPerformed(ActionEvent ae) {
    			window.Connection();
    		}
    }

    class DisconnectionActionImpl implements ActionListener {
		public void actionPerformed(ActionEvent ae) {
			setConnected(false);
			window.Disconnection();
		}
    }
    
    class PreferencesActionImpl implements ActionListener {
    		public void actionPerformed(ActionEvent ae) {
    			PreferencesWindow.show();
    		}
    }

    class SelectedActionImpl implements ActionListener {
    		final private String encoding;
	
    		SelectedActionImpl(String encoding) {
    			this.encoding = encoding;
    		}
	
    		public void actionPerformed(ActionEvent ae) {
    			window.setENC(this.encoding);
    		}
    }
    
    class QuitActionImpl implements ActionListener {
    		public void actionPerformed(ActionEvent ae) {
    			window.exit();
    		}
    }
    
    class JoinActionImpl implements ActionListener {
    		public void actionPerformed(ActionEvent ae) {
	    /*
	    String channel =
		JOptionPane.showInputDialog("please input channel name");
	    window.setJOIN(channel);
	    */
    		}
    }
    
    class PartActionImpl implements ActionListener {
    		public void actionPerformed(ActionEvent ae) {
    			window.setPART(window.getNowChannel());
    		}
    }
    
    class TopicActionImpl implements ActionListener {
    		public void actionPerformed(ActionEvent ae) {
	    /*
	      String topic =
	      JOptionPane.showInputDialog("please input channel topic");
	      
	      window.setTOPIC(window.getNowChannel(), topic);
	    */
    		}
    }

    class NickActionImpl implements ActionListener {
    		public void actionPerformed(ActionEvent ae) {
	    /*
	    String nick = JOptionPane.showInputDialog("please input new nick");

	    window.setNICK(nick);
	    */
    		}
    }
}
