package jp.sourceforge.jirc;

import jp.sourceforge.jirc.net.Channel;

public class ChannelMode {
    private boolean moderationFlag = false;
    private boolean anonymousFlag = false;
    private boolean privateFlag = false;
    private boolean secretFlag = false;
    private boolean publicFlag = false;
    private boolean inviteFlag = false;
    private boolean noticeFlag = false;
    private boolean topicFlag = false;
    private boolean reopFlag = false;

    private String limit = null;
    private String keyword = null;

    private final Channel channel;
    
    ChannelMode(Channel channel) {
	this.channel = channel;
    }

    public void setInvite(boolean flag) {
	inviteFlag = flag;
    }

    public void setNotice(boolean flag) {
	noticeFlag = flag;
    }

    public void setReop(boolean flag) {
	reopFlag = flag;
    }

    public void setTopic(boolean flag) {
	topicFlag = flag;
    }

    public void setAnonymous(boolean flag) {
	anonymousFlag = flag;
    }

    public void setSecret(boolean flag) {
	secretFlag = flag;
    }

    public void setPrivate(boolean flag) {
	privateFlag = flag;
    }

    public void setPublic(boolean flag) {
	publicFlag = flag;
    }

    public void setKeyword(String keyword, boolean flag) {
	if(flag) {
	    this.keyword = keyword;
	} else {
	    this.keyword = null;
	}
    }

    public void setModeration(boolean flag) {
	moderationFlag = flag;
    }

    public void setLimit(String limit, boolean flag) {
	if(flag) {
	    this.limit = limit;
	} else {
	    this.limit = null;
	}
    }

    public String toString() {
	String mode = "";
	
	if(secretFlag) {
	    mode += "s";
	} 

	if(privateFlag) {
	    mode += "p";
	}

	if(topicFlag) {
	    mode += "t";
	}

	if(inviteFlag) {
	    mode += "i";
	}

	if(noticeFlag) {
	    mode += "n";
	}

	if(moderationFlag) {
	    mode += "m";
	}

	if(limit != null) {
	    mode += "l " + limit + " ";
	}

	if(keyword != null) {
	    mode += "k " + keyword + " ";
	}

	if(!mode.equals("")) {
	    mode = "[" + mode + "]";
	}

	return mode;
    }
}
