package jp.sourceforge.jirc;

import java.util.Date;
import java.text.SimpleDateFormat;

import jp.sourceforge.jirc.net.AbstractChannel;
import jp.sourceforge.jirc.net.IRC;
import jp.sourceforge.jirc.text.IRCMessageFormat;

abstract class ChildWindow extends AbstractChannel {
    private String name;
    protected String CRLF = "\r\n";
    private SimpleDateFormat formater = new SimpleDateFormat("HH:mm");

    private final ClientComponent window;

    ChildWindow(String name, IRC irc, ClientComponent win) {
    		super(irc);
    		this.name = name;
    		this.window = win;
    }
    
    protected String getTime() {
    		return formater.format(new Date());
    }
    
    public String toString() {
    		return name;
    }

    void setChannelName(String name) {
    		this.name = name;
    		window.setTopic();
    }

    public void setMode(String nick, String modeString) {
    		String[] args = {nick, name, modeString};

    		append(IRCMessageFormat.getModeMessage(args));
    		setMode(modeString);
    }

    public void setMode(String modeString) {
    		super.setMode(modeString);
    		window.setTopic();
    }
    
    public void setTopic() {
    		setTopic(getTopic());
    }

    public void setTopic(String topic) {
    		super.setTopic(topic);

    		String title = name + ' ' + getMode().toString() + ' ' + topic + " - ";
		window.setTopic(title);
	}

    public void writeMessage(String string) {
    		window.writeMessage(name, string);
    }
}
