package jp.sourceforge.jirc;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

class ConnectionDialog {
    private final Window client;
    private Dialog dialog;
    
    ConnectionDialog(Window client) {
		this.client = client;

		Frame frame = new Frame();
    		frame.setSize(640, 480);

    		dialog = new Dialog(frame);
    		dialog.add(PreferencesWindow.getTextPanel(), BorderLayout.EAST);
    		dialog.add(getButtonPanel(), BorderLayout.SOUTH);
    		dialog.setResizable(false);
    		dialog.pack();
//    		dialog.validate();
    		dialog.show();
    }
    
    void show() {
    		dialog.show();
    }

    private Panel getButtonPanel() {
    		Panel panel = new Panel(new FlowLayout());
	
    		Button OKButton = new Button(ClientMessage.getMessage("connection"));
    		Button CancelButton = new Button(ClientMessage.getMessage("cancel"));
	
    		OKButton.addActionListener(new DialogOKListener());
    		CancelButton.addActionListener(new DialogCancelListener());

    		panel.add(OKButton);
    		panel.add(CancelButton);

    		return panel;
    }

    public void OKAction() {
    		String value[] = PreferencesWindow.saveConnectionPreferences();

    		String server   = value[0];
    		String port     = value[1];
    		String nick     = value[2];
    		String password = value[3];
    		String channels = value[4];
    		String frame    = value[5];
    		
    		Integer num = new Integer(port);

    		if(frame == "Swing") {
    			client.SwingFrame();
    		} else {
    			client.AWTFrame();
    		}
    		client.show();
	
    		try {
    			if(channels.length() > 0) {
    				client.Connection(server, num.intValue(), nick, "jIRC", password, channels);
    			} else {
    				client.Connection(server, num.intValue(), nick, "jIRC", password);
    			}
    			dialog.setVisible(false);
    		} catch(Exception e) {
    			e.printStackTrace();
    		}
    }
    
    public void CancelAction() {
    		dialog.setVisible(false);
//    		System.exit(0);
    }

    private class DialogOKListener implements ActionListener {
    		public void actionPerformed(ActionEvent ae) {
    			OKAction();
    		}
    }

    private class DialogCancelListener implements ActionListener {
    		public void actionPerformed(ActionEvent ae) {
    			CancelAction();
    		}
    }
}
