/*
 * Created on 2004/05/01
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package jp.sourceforge.jirc;

import java.awt.*;
import java.awt.event.*;

/**
 * @author nog
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
class PreferencesWindow {
	/**
	 * 
	 */
    private static String SWING = "Swing";
    private static String AWT   = "AWT";
    private static String[] FRAME_LIST = {AWT, SWING}; 

    private static CardLayout cardLayout = new CardLayout();
    private static Panel panel = new Panel(cardLayout);
    private static Frame frame = new Frame();
    private static List  list = new List();

    private static Panel textPanel = null;
    private static Panel generalPanel = null;

    private static TextField serverTextField = new TextField("", 20);
    private static TextField portTextField = new TextField();
    private static TextField nickTextField = new TextField();
    private static TextField passwordField = new TextField();
    private static TextField channelsTextField = new TextField();
    private static Choice comboBox;
    
    private static TextField logDirectoryTextField = new TextField("", 20);

    static {
    		list.addItemListener(new ListListener());

    		frame.addWindowListener(new WindowClosingListener());
   		frame.setResizable(false);
    }
    
    private static class WindowClosingListener extends WindowAdapter {
    		public void windowClosing(WindowEvent e) {
			close();
		}
    }
    
    private static class ListListener implements ItemListener {
    		ListListener() {
    		}
    		
    		public void itemStateChanged(ItemEvent e	) {
   			cardLayout.show(panel, list.getSelectedItem());
			frame.pack();
			frame.show();
    		}
    }
	
	public static void show() {
		frame.removeAll();
		frame.add(list,  BorderLayout.WEST);
		frame.add(panel, BorderLayout.CENTER);
		
		if(list.getItemCount() < 1) {
			addPanel(getTextPanel(), "Connection");
			addPanel(getGeneralPanel(), "General");
		}

		frame.validate();
		frame.show();
	}
	
	private static void addPanel(Panel child, String string) {
		list.add(string);
		panel.add(child, string);
	}
	
	public static void close() {
		frame.setVisible(false);

		saveConnectionPreferences();
		saveGeneralPreferences();
	}

	static Panel getTextPanel() {
		if(textPanel == null	) {
			textPanel = createTextPanel();
		}
		
		return textPanel;
    }
    
	static Panel getGeneralPanel() {
		if(generalPanel == null	) {
			generalPanel = createGeneralPanel();
		}
		
		return generalPanel;
    }

	static String[] saveConnectionPreferences() {
		String server   = serverTextField.getText();
		String port     = portTextField.getText();
		String nick     = nickTextField.getText();
		String password = passwordField.getText();
		String channels = channelsTextField.getText();
		String frame    = (String )comboBox.getSelectedItem();
		
		jIRCPreferences.setServerProperty(server);
		jIRCPreferences.setPortProperty(port);
		jIRCPreferences.setNickProperty(nick);
		jIRCPreferences.setChannelsProperty(channels);
		
		storePreferences();
		
		String[] value = {server, port, nick, password, channels, frame};

		return value;
    }

	static String saveGeneralPreferences() {
		String log = logDirectoryTextField.getText();
		
		jIRCPreferences.setLogDirectoryProperty(log);
		
		storePreferences();		
		
		return log;
	}
	
	private static void storePreferences() {
		try {
			jIRCPreferences.store();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	private static Panel createTextPanel() {
		Panel panel = new Panel(new GridBagLayout());

		GridBagConstraints constraints = new GridBagConstraints();
		constraints.fill = GridBagConstraints.BOTH;

		serverTextField.setText(jIRCPreferences.getServerProperty());
		portTextField.setText(jIRCPreferences.getPortProperty());
		nickTextField.setText(jIRCPreferences.getNickProperty());
		passwordField.setText("");
		channelsTextField.setText(jIRCPreferences.getChannelsProperty());
		comboBox = new Choice();
		
		for(int i = 0; i < FRAME_LIST.length; i++) {
			comboBox.add(FRAME_LIST[i]);
		}

		addComponent(panel, constraints, new Insets(12, 12,  0,  7), 0, 0,
				getLabel(ClientMessage.getMessage("server")));
		addComponent(panel, constraints, new Insets(12,  0,  0, 11), 1, 0,
				serverTextField);
		addComponent(panel, constraints, new Insets( 5, 12,  0,  7), 0, 1,
				getLabel(ClientMessage.getMessage("port")));
		addComponent(panel, constraints, new Insets( 5,  0,  0, 11), 1, 1,
				portTextField);
		addComponent(panel, constraints, new Insets( 5, 12,  0,  7), 0, 2,
				getLabel(ClientMessage.getMessage("nick")));
		addComponent(panel, constraints, new Insets( 5,  0,  0, 11), 1, 2,
				nickTextField);
		addComponent(panel, constraints, new Insets( 5, 12,  0,  7), 0, 3,
				getLabel(ClientMessage.getMessage("password")));
		addComponent(panel, constraints, new Insets( 5,  0,  0, 11), 1, 3,
				passwordField);
		addComponent(panel, constraints, new Insets( 5, 12,  0,  7), 0, 4,
				getLabel(ClientMessage.getMessage("channel")));
		addComponent(panel, constraints, new Insets( 5,  0,  0, 11), 1, 4,
				channelsTextField);
		addComponent(panel, constraints, new Insets( 5,  0,  0, 11), 1, 5,
				comboBox);	

		return panel;
    }
    
    private static Panel createGeneralPanel() {
    		Panel panel = new Panel(new GridBagLayout());

    		GridBagConstraints constraints = new GridBagConstraints();
    		constraints.fill = GridBagConstraints.BOTH;
    		
    		logDirectoryTextField.setText(jIRCPreferences.getLogDirectoryProperty())	;
    		
    		addComponent(panel, constraints, new Insets(12, 12,  0,  7), 0, 0,
    				getLabel(ClientMessage.getMessage("logDirectory")));
    		addComponent(panel, constraints, new Insets(12,  0,  0, 11), 1, 0,
    				logDirectoryTextField);
    		
    		return panel;
    }
    
    private static void addComponent(Container container, GridBagConstraints constraints,
    		Insets insets, int gridx, int gridy, Component component) {
    		constraints.insets = insets;
    		constraints.gridx = gridx;
    		constraints.gridy = gridy;
    		container.add(component, constraints);
    }
    
    private static Component getLabel(String title) {
		return new Label(title, Label.LEFT);
    }
}
