package jp.sourceforge.jirc.net;

import java.util.StringTokenizer;
import java.util.Vector;

abstract public class AbstractChannel implements Channel {
    private String topic = "";

    private ChannelMode mode = new ChannelMode(this);    
    private IRC irc;

    public AbstractChannel(IRC irc) {
    		this.irc = irc;
    }

    public boolean hasTopic() {
    		if(topic.equals("")) {
    			return false;
    		} else {
    			return true;
    		}
    }

    public void setTopic(String topic) {
    		this.topic = topic;
    }

    public String getTopic() {
    		return topic;
    }

    public ChannelMode getMode() {
    		return mode;
    }

    public IRC getIRC() {
    		return irc;
    }
    
    public void setMode(String modeString) {
    		boolean flag = false;
    		String modes = modeString;
    		Vector value = null;
    		int valueCount = 0;
	
    		if(modeString.indexOf(' ') > 0) {
    			value = new Vector();
    			StringTokenizer st = new StringTokenizer(modeString, " ", false);
    			modes = st.nextToken().trim();
    			while(st.hasMoreTokens()) {
    				value.add(st.nextToken().trim());
    			}
    		}

    		for(int i = 0; i < modes.length(); i++) {
    			switch(modes.charAt(i)) {
    				case '+':
    					flag = true;
    					break;
    				case '-':
    					flag = false;
    					break;
    				case 'O':
    					break;
    				case 'o':
    					setChanop((String )value.get(valueCount++), flag);
    					break;
    				case 'v':
    					setVoice((String )value.get(valueCount++), flag);
    					break;
    				case 'a':
    					mode.setAnonymous(flag);
    					break;
    				case 'i':
    					mode.setInvite(flag);
    					break;
    				case 'm':
    					mode.setModeration(flag);
    					break;
    				case 'n':
    					mode.setNotice(flag);
    					break;
    				case 'q':
    					break;
    				case 'p':
    					mode.setPrivate(flag);
    					break;
    				case 's':
    					mode.setSecret(flag);
    					break;
    				case 'r':
    					mode.setReop(flag);
    					break;
    				case 't':
    					mode.setTopic(flag);
    					break;
    				case 'k':
    					mode.setKeyword((String )value.get(valueCount++), flag);
    					break;
    				case 'l':
    					if(flag) {
    						mode.setLimit((String )value.get(valueCount++), flag);
    					}
    					break;
    				case 'b':
    					break;
    				case 'e':
    					break;
    				case 'I':
    					break;
    				default:
    					break;
    			}
    		}
    }
}
