package jp.sourceforge.jirc.text;

import java.text.MessageFormat;
import java.util.ResourceBundle;

public class IRCMessageFormat {
    private static ResourceBundle bundle = ResourceBundle.getBundle("jp.sourceforge.jirc.text.IRCMessage"); 

    public IRCMessageFormat() {
    }

    static String format(String string, String[] args) {
    		return MessageFormat.format(bundle.getString(string), args);
    }

    public static String getJoinMessage(String[] args) {
    		return format("join", args);
    }

    public static String getPartMessage(String[] args) {
    		if(args[2].equals("")) {
    			return format("part", args);
    		} else {
    			return format("partx", args);
    		}
    }

    public static String getKickMessage(String[] args) {
    		if(args.length > 2) {
    			return format("kickx", args);
    		} else {
    			return format("kick", args);
    		}
    }

    public static String getModeMessage(String[] args) {
    		if(args.length > 2) {
    			return format("mode", args);
    		} else {
    			return format("modex", args);
    		}
    }

    public static String getPrivmsgMessage(String[] args) {
    		return format("message_to_channel1x", args);
    }

    public static String getPrivmsgFullMessage(String[] args) {
    		return format("message_to_channel1", args);
    }

    public static String getNoticeMessage(String[] args) {
    		return format("message_to_channel2x", args);
    }

    public static String getNoticeFullMessage(String[] args) {
    		return format("message_to_channel2", args);
    }

    public static String getTopicMessage(String[] args) {
    		return format("topic", args);
    }

    public static String getQuitMessage(String[] args) {
    		return format("quit", args);
    }

    public static String getNickMessage(String[] args) {
    		return format("nick", args);
    }
    
    public static String getKillMessage(String[] args) {
    		return format("kill", args);
    }
    
    public static String getInviteMessage(String[] args) {
    		return format("invite", args);
    }
    
    public static String getWallopsMessage(String[] args) {
    		return format("wallops", args);
    }
    
    public static String getCTCPMessage(String[] args) {
		return format("ctcp", args);
    }
    
    public static String getActionMessage(String[] args) {
    		return format("action_to_channelx", args);
    }
    
    public static String getErrorMessage(String[] args) {
    		return format("error", args);
    }
}
